import{jsxs as t,jsx as i,Fragment as e}from"react/jsx-runtime";import{useState as o}from"react";import{Card as r,Icon as n,Typography as a,Button as l}from"@equinor/eds-core-react";import{info_circle as h}from"@equinor/eds-icons";import{useTutorials as s,useTutorialStepImage as m}from"@equinor/subsurface-app-management";import{useTutorialHighlighting as d}from"../TutorialHighlightingProvider.js";import{TUTORIAL_HIGHLIGHT_ANIMATION_PROPS as g}from"../TutorialHighlightingProvider.constants.js";import{StepIndicator as c}from"./StepIndicator.js";import{elevation as p}from"../../../atoms/style/index.js";import{useTutorialPopoverPosition as u}from"./hooks/useTutorialPopoverPosition.js";import{motion as f}from"framer-motion";import v,{css as $}from"styled-components";import{spacings as x}from"../../../atoms/style/spacings.js";import{colors as y}from"../../../atoms/style/colors.js";const b=v(f(r))`
  width: 360px;
  padding: ${x.medium};
  background: ${y.infographic.primary__moss_green_13.rgba};
  display: flex;
  flex-direction: column;
  gap: ${x.medium};
  transition:
    top 400ms,
    left 400ms;
  box-shadow: ${p.raised};
  pointer-events: auto;
  > header {
    display: flex;
    gap: ${x.small};
    align-items: center;
  }
  > img {
    max-height: 170px;
    object-fit: contain;
  }
  ${({$highlightingElement:t,$highlightDirection:i})=>t&&$`
      transform: translateX(-50%);
      &:before {
        z-index: -1;
        content: '';
        width: 32px;
        height: 32px;
        background: ${y.infographic.primary__moss_green_13.rgba};
        position: absolute;
        ${"top"===i||"bottom"===i?$`
              left: 50%;
              ${i}: 0;
              transform: translate(-50%, 0) rotate(45deg);
            `:$`
              top: 50%;
              ${i}: 0;
              transform: translate(0, -50%) rotate(45deg);
            `}
      }
    `}
`,_=v.div`
  display: flex;
  justify-content: flex-end;
  gap: ${x.small};
  &:has(> :last-child:nth-child(3)) {
    > button:first-child {
      margin-right: auto;
    }
  }
`,k=({isHighlighting:r,id:p,top:f,left:v,width:$,height:x,name:k,steps:j})=>{const{customStepContent:w}=d(),{activeTutorial:T,activeStep:C,skipTutorial:S,startTutorial:D,goToNextStep:P,goToPreviousStep:E}=s(),{data:H}=m(T?.steps.at(C)?.imgUrl??void 0),[q,I]=o(void 0),{style:z,highlightingElement:N,highlightDirection:A}=u({top:f,left:v,width:$,height:x,popoverSize:q}),B=t=>{I(t?{width:t.clientWidth,height:t.clientHeight}:void 0)},F=()=>{S(p)},U=()=>{D(p)};if(void 0!==C&&j[C].custom&&!w[j[C].id])throw new Error(`[TutorialHighlightingProvider]: Custom step content not found, tutorial ID: ${p}, step ID: ${j[C].id}`);return!N&&r?null:t(b,T&&void 0!==C?{ref:B,style:{...z,width:j[C].custom?"auto":void 0},$highlightDirection:A,$highlightingElement:N,...g,children:[j[C].custom?w[j[C].id]:t(e,{children:[t("header",{children:[i(n,{data:h,color:y.interactive.primary__resting.rgba}),i(a,{variant:"h6",children:j[C]?.title})]}),i(a,{variant:"body_short",children:j[C]?.body}),H?i("img",{src:H,alt:j[C].title}):null]}),t(_,{children:[i(l,{variant:"outlined",disabled:0===C,onClick:E,children:"Back"}),i(l,{variant:"ghost",onClick:F,children:"Cancel"}),i(l,{onClick:P,children:C===j.length-1?"Finish":"Next"})]}),i(c,{stepAmount:j.length})]}:{ref:B,style:{...z},$highlightingElement:N,$highlightDirection:A,...g,children:[t("header",{children:[i(n,{data:h,color:y.interactive.primary__resting.rgba}),i(a,{variant:"h6",children:k})]}),t(_,{children:[i(l,{variant:"ghost",onClick:F,children:"Skip"}),i(l,{onClick:U,children:"Start tour"})]})]})};export{k as TutorialPopover};
