import { MotionStyle } from 'framer-motion';
interface UseTutorialPopoverPositionArgs {
    top?: number;
    left?: number;
    width?: number;
    height?: number;
    popoverSize?: {
        width: number;
        height: number;
    };
}
export interface UseTutorialPopoverPositionReturn {
    style: MotionStyle;
    highlightingElement: boolean;
    highlightDirection: 'top' | 'bottom' | 'left' | 'right';
}
export declare function useTutorialPopoverPosition({ top, left, width, height, popoverSize, }: UseTutorialPopoverPositionArgs): UseTutorialPopoverPositionReturn;
export {};
